// mpicc 3c-barrier-YES.c -Wall -o test.x

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <math.h>

int main( int argc, char *argv[] )
{
   int me=0, nProcs, i,j,k,n;
   double aux = 1.0, MPItime;
   
   MPI_Init(&argc,&argv);
   MPI_Comm_rank( MPI_COMM_WORLD, &me );
   MPI_Comm_size( MPI_COMM_WORLD, &nProcs );

   srand48( (unsigned) me );
   n = (int) floor( drand48()*1000 );
   printf(" [%d] local data: %d\n", me, n );
   MPI_Barrier( MPI_COMM_WORLD );  
   
   printf(" [%d]\t before barrier\n", me );
   MPI_Barrier( MPI_COMM_WORLD );  
   MPItime = MPI_Wtime();
   
   /* random computation */
   for( i=0; i<n; i++ )
      for( j=0; j<n; j++ )
         for( k=0; k<n; k++ )
            aux *= 1.0000000023;
   
   MPI_Barrier( MPI_COMM_WORLD );
   MPItime = MPI_Wtime() - MPItime;
   // MPI_Reduce  [to be done later]


   if( me == 0 ) 
      printf( " [%d]  \t\ttime: %lf\t\taux: %lf\n", me, MPItime, aux );

   
   MPI_Finalize();
   return 0;
}


