// mpicc 6a-scatter.c -Wall -o test.x

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <time.h>

int main( int argc, char *argv[] )
{
   int me=0, nProcs, size=5, i, j, *buffer=NULL, *recbuffer=NULL;

   MPI_Init( &argc, &argv );
   MPI_Comm_rank( MPI_COMM_WORLD, &me );
   MPI_Comm_size( MPI_COMM_WORLD, &nProcs );

   int root = 0;
   
   if( me == root ){
      buffer = (int *) malloc( size * nProcs * sizeof(int) );
      for( i=0; i<nProcs; i++ )
         for( j=0; j<size; j++ )
            buffer[size*i+j]=1000*i+i+j;

      for( i=0; i<nProcs*size; i++ )
         printf( "(%d) source[%d]=%d\n", me, i, buffer[i]);
   }

   recbuffer = (int *) malloc( size * sizeof(int) );

   MPI_Scatter( buffer,    size, MPI_INT,
                recbuffer, size, MPI_INT, root, MPI_COMM_WORLD );

   for( i=0; i<size; i++ )
      printf( "(%d) \t\t\treceived[%d]=%d\n", me, i, recbuffer[i]);

   MPI_Finalize();
   free( recbuffer );
   return 0;
}


